"use strict";

const e = require("http"), t = require("path"), s = require("escape-html"), r = require("content-type"), n = require("cookie"), i = require("cookie-signature"), o = require("on-finished"), a = require("content-disposition"), c = require("send"), h = require("./utils"), u = t.resolve, p = e.STATUS_CODES, l = /;\s*charset\s*=/, d = (e, t) => {
    if (!e || !t) return e;
    // parse type
        const s = r.parse(e);
    // set charset
        // format type
    return s.parameters.charset = t, r.format(s);
}, f = (e, t, s, r) => 
// v8 checks arguments.length for optimizing simple call
// https://bugs.chromium.org/p/v8/issues/detail?id=4730
r ? JSON.stringify(e, t, s).replace(/[<>&]/g, e => {
    switch (e.charCodeAt(0)) {
      case 60:
        return "\\u003c";

      case 62:
        return "\\u003e";

      case 38:
        return "\\u0026";

      default:
        return e;
    }
}) : JSON.stringify(e, t, s), y = e => "/" === e[0] || (":" === e[1] && ("\\" === e[2] || "/" === e[2]) || (// Windows device path
"\\\\" === e.substring(0, 2) || void 0)), g = (e, t, s, r) => {
    let n, i = !1;
    // request aborted
    function a() {
        if (i) return;
        i = !0;
        const e = new Error("Request aborted");
        e.code = "ECONNABORTED", r(e);
    }
    // directory
        // errors
    function c(e) {
        i || (i = !0, r(e));
    }
    // ended
        t.on("directory", function() {
        if (i) return;
        i = !0;
        const e = new Error("EISDIR, read");
        e.code = "EISDIR", r(e);
    }), t.on("end", function() {
        i || (i = !0, r());
    }
    // file
    ), t.on("error", c), t.on("file", function() {
        n = !1;
    }
    // finished
    ), t.on("stream", 
    // streaming
    function() {
        n = !0;
    }), o(e, function(e) {
        return e && "ECONNRESET" === e.code ? a() : e ? c(e) : void (i || setImmediate(() => {
            !1 === n || i ? i || (i = !0, r()) : a();
        }));
    }), s.headers && 
    // set headers on successful transfer
    t.on("headers", e => {
        const t = s.headers, r = Object.keys(t);
        let n;
        for (let s = 0; s < r.length; s++) n = r[s], e.setHeader(n, t[n]);
    }), 
    // pipe
    t.pipe(e);
}, m = e => ~e.indexOf("/") ? ((e, t) => {
    const s = e.split(/ *; */), r = {
        value: s[0],
        quality: 1,
        params: {},
        originalIndex: t
    };
    let n;
    for (let e = 1; e < s.length; ++e) "q" === (n = s[e].split(/ *= */))[0] ? r.quality = parseFloat(n[1]) : r.params[n[0]] = n[1];
    return r;
})(e) : {
    value: c.mime.lookup(e),
    params: {}
}, T = e => {
    const t = [];
    for (let s = 0; s < e.length; ++s) t.push(exports.normalizeType(e[s]));
    return t;
};

class E extends e.ServerResponse {
    /**
     *
     * @param req request
     */
    constructor(e) {
        super(e), this.req = e;
    }
    /**
     * Check if the request is fresh, aka
     * Last-Modified and/or the ETag
     * still match.
     */    get fresh() {
        const e = this.req, t = e.method;
        // GET or HEAD for weak freshness validation only
        if ("GET" !== t && "HEAD" !== t) return !1;
        const s = this.statusCode;
        // 2xx or 304 as per rfc2616 14.26
                return (s >= HTTP.OK && s < HTTP.MULTIPLE_CHOICES || HTTP.NOT_MODIFIED === s) && h.fresh(e.headers, this.get("last-modified"));
    }
    /**
     * Check if the request is stale, aka
     * "Last-Modified" and / or the "ETag" for the
     * resource has changed.
     */    get stale() {
        return !this.fresh;
    }
    /**
     * Append additional header `field` with value `val`.
     *
     * @returns for chaining
     * @example
     * res.append("Link", ["<http://localhost/>", "<http://localhost:3000/>"]);
     * @example
     * res.append("Set-Cookie", "foo=bar; Path=/; HttpOnly");
     * @example
     * res.append("Warning", "199 Miscellaneous warning");
     */    append(e, t) {
        const s = this.get(e);
        let r = t;
        return s && (
        // concat the new and prev vals
        r = Array.isArray(s) ? s.concat(t) : Array.isArray(t) ? [ s ].concat(t) : [ s, t ]), 
        this.set(e, r);
    }
    /**
     * Set _Content-Disposition_ header to _attachment_ with optional `filename`.
     */    attachment(e) {
        return e && this.type(t.extname(e)), this.set("content-disposition", a(e)), this;
    }
    /**
     * Clear cookie `name`.
     *
     * @returns for chaining
     */    clearCookie(e, t = {}) {
        const s = Object.assign({}, {
            expires: new Date(1),
            path: "/"
        }, t);
        return this.cookie(e, "", s);
    }
    /**
     * Set _Content-Type_ response header with `type` through `mime.lookup()`
     * when it does not contain "/", or set the Content-Type to `type` otherwise.
     *
     * @returns for chaining
     * @example
     * res.type(".html");
     * @example
     * res.type("html");
     * @example
     * res.type("json");
     * @example
     * res.type("application/json");
     * @example
     * res.type("png");
     */    contentType(e) {
        return this.set("content-type", -1 === e.indexOf("/") ? c.mime.lookup(e) : e);
    }
    /**
     * Set cookie `name` to `value`, with the given `options`.
     *
     * Options:
     *    - `maxAge`   max-age in milliseconds, converted to `expires`
     *    - `signed`   sign the cookie
     *    - `path`     defaults to "/"
     *
     * @returns for chaining
     * @example
     * // "Remember Me" for 15 minutes
     * res.cookie("rememberme", "1", { expires: new Date(Date.now() + 900000), httpOnly: true });
     * @example
     * // save as above
     * res.cookie("rememberme", "1", { maxAge: 900000, httpOnly: true })
     */    cookie(e, t, s = {}) {
        const r = Object.assign({}, s), o = this.req.secret, a = r.signed;
        if (a && !o) throw new Error("cookieParser('secret') required for signed cookies");
        let c = h.object.isObject(t) ? "j:" + JSON.stringify(t) : String(t);
        return a && (c = "s:" + i.sign(c, o)), "maxAge" in r && (r.expires = new Date(Date.now() + r.maxAge), 
        r.maxAge /= 1e3), null == r.path && (r.path = "/"), this.append("Set-Cookie", n.serialize(e, String(c), r)), 
        this;
    }
    /**
     * Transfer the file at the given `path` as an attachment.
     *
     * Optionally providing an alternate attachment `filename`,
     * and optional callback `callback(err)`. The callback is invoked
     * when the data transfer is complete, or when an error has
     * ocurred. Be sure to check `res.headersSent` if you plan to respond.
     *
     * Optionally providing an `options` object to use with `res.sendFile()`.
     * This function will set the `Content-Disposition` header, overriding
     * any `Content-Disposition` header passed as header options in order
     * to set the attachment and filename.
     *
     * This method uses `res.sendFile()`.
     */    download(e, t, s, r) {
        let n = r, i = t, o = s || null;
        // support function as second or third arg
        h.function.isFunction(t) ? (n = t, i = null, o = null) : h.function.isFunction(s) && (n = s, 
        o = null);
        // set Content-Disposition when file is sent
                const c = {
            "content-disposition": a(i || e)
        };
        // merge user-provided headers
                if (o && o.headers) {
            const e = Object.keys(o.headers);
            let t;
            for (let s = 0; s < e.length; s++) "content-disposition" !== (t = e[s]).toLowerCase() && (c[t] = o.headers[t]);
        }
        // merge user-provided options
                o = Object.create(o)(o).headers = c;
        // Resolve the full path for sendFile
        const p = u(e);
        // send file
                return this.sendFile(p, o, n);
    }
    /**
     * Respond to the Acceptable formats using an `obj`
     * of mime-type callbacks.
     *
     * This method uses `req.accepted`, an array of
     * acceptable types ordered by their quality values.
     * When "Accept" is not present the _first_ callback
     * is invoked, otherwise the first match is used. When
     * no match is performed the server responds with
     * 406 "Not Acceptable".
     *
     * By default Foxify passes an `Error`
     * with a `.status` of 406 to `next(err)`
     * if a match is not made. If you provide
     * a `.default` callback it will be invoked
     * instead.
     *
     * Content-Type is set for you, however if you choose
     * you may alter this within the callback using `res.type()`
     * or `res.set("Content-Type", ...)`.
     *
     * @returns for chaining
     * @example
     * res.format({
     *   "text/plain": function() {
     *     res.send("hey");
     *   },
     *   "text/html": function() {
     *     res.send("<p>hey</p>");
     *   },
     *   "appliation/json": function() {
     *     res.send({ message: "hey" });
     *   }
     * });
     * @example
     * // In addition to canonicalized MIME types you may
     * // also use extnames mapped to these types:
     *
     * res.format({
     *   text: function() {
     *     res.send("hey");
     *   },
     *   html: function() {
     *     res.send("<p>hey</p>");
     *   },
     *   json: function() {
     *     res.send({ message: "hey" });
     *   }
     * });
     */    format(e) {
        const t = this.req, s = this.next, r = e.default;
        r && delete e.default;
        const n = Object.keys(e), i = n.length > 0 && t.accepts(...n);
        if (this.vary("Accept"), i) this.set("content-type", m(i).value), e[i](t, this, s); else {
            if (!r) {
                const e = new Error("Not Acceptable");
                throw e.status = e.statusCode = 406, e.types = T(n).map(e => e.value), e;
            }
            r();
        }
        return this;
    }
    /**
     * Set header `field` to `val`, or pass
     * an object of header fields.
     *
     * @returns for chaining
     * @example
     * res.set("Foo", ["bar", "baz"]);
     * @example
     * res.set("Accept", "application/json");
     * @example
     * res.set({ Accept: "text/plain", "X-API-Key": "tobi" });
     */    header(e, t) {
        if (t) {
            let s = Array.isArray(t) ? t.map(e => `${e}`) : `${t}`;
            // add charset to content-type
                        if ("content-type" === e.toLowerCase()) {
                if (Array.isArray(s)) throw new TypeError("Content-Type cannot be set to an Array");
                if (!l.test(s)) {
                    const e = c.mime.charsets.lookup(s.split(";")[0]);
                    e && (s += "; charset=" + e.toLowerCase());
                }
            }
            this.setHeader(e, s);
        } else for (const t in e) this.set(t, e[t]);
        return this;
    }
    /**
     * Send JSON response.
     *
     * @example
     * res.json({ user: "tj" });
     */    json(e, t) {
        void 0 !== t && this.status(t), this.setHeader("content-type", "application/json");
        const s = this.settings.json;
        return this.send((this.stringify[this.statusCode] || f)(e, s.replacer, s.spaces, s.escape));
    }
    /**
     * Send JSON response with JSONP callback support.
     *
     * @example
     * res.jsonp({ user: "tj" });
     */    jsonp(e, t) {
        // settings
        const s = this.app, r = this.settings.json, n = r.escape, i = r.replacer, o = r.spaces;
        let a = f(e, i, o, n), c = this.req.query[s.get("jsonp callback name")];
        return t && this.status(t), 
        // content-type
        this.get("content-type") || (this.set("x-content-type-options", "nosniff"), this.set("content-type", "application/json")), 
        // fixup callback
        Array.isArray(c) && (c = c[0]), 
        // jsonp
        h.string.isString(c) && 0 !== c.length && (this.set("x-content-type-options", "nosniff"), 
        this.set("content-type", "text/javascript"), 
        // the /**/ is a specific security mitigation for "Rosetta Flash JSONP abuse"
        // the typeof check is just to reduce client error noise
        a = "/**/ typeof " + (
        // restrict callback charset
        c = c.replace(/[^\[\]\w$.]/g, "")) + " === 'function' && " + c + "(" + (
        // replace chars not allowed in JavaScript that are in JSON
        a = a.replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029")) + ");"), this.send(a);
    }
    /**
     * Set Link header field with the given links.
     *
     * @example
     * res.links({
     *   next: "http://api.example.com/users?page=2",
     *   last: "http://api.example.com/users?page=5"
     * });
     */    links(e) {
        return this.set("link", `${this.get("link") || ""}, ` + Object.keys(e).map(t => `<${e[t]}>; rel="${t}"`).join(", "));
    }
    /**
     * Set the location header to `url`.
     *
     * The given `url` can also be "back", which redirects
     * to the _Referrer_ or _Referer_ headers or "/".
     *
     * @returns for chaining
     * @example
     * res.location("/foo/bar").;
     * @example
     * res.location("http://example.com");
     * @example
     * res.location("../login");
     */    location(e) {
        return this.set("location", h.encodeUrl(
        // "back" is an alias for the referrer
        "back" === e ? this.req.get("referrer") || "/" : e));
    }
    /**
     * Redirect to the given `url` with optional response `status`
     * defaulting to 302.
     *
     * The resulting `url` is determined by `res.location()`, so
     * it will play nicely with mounted apps, relative paths,
     * `"back"` etc.
     *
     * @example
     * res.redirect("/foo/bar");
     * @example
     * res.redirect("http://example.com");
     * @example
     * res.redirect("http://example.com", 301);
     * @example
     * res.redirect("../login"); // /blog/post/1 -> /blog/login
     */    redirect(e, t = 302) {
        let r = e, n = "";
        // Set location header
        r = this.location(r).get("Location"), 
        // Support text/{plain,html} by default
        this.format({
            text: () => {
                n = p[t] + ". Redirecting to " + r;
            },
            html: () => {
                const e = s(r);
                n = "<p>" + p[t] + '. Redirecting to <a href="' + e + '">' + e + "</a></p>";
            },
            default: () => {
                n = "";
            }
        }), 
        // Respond
        this.statusCode = t, this.set("content-length", Buffer.byteLength(n)), "HEAD" === this.req.method ? this.end() : this.end(n);
    }
    render(e, t, s) {
        const r = this.settings.engine;
        if (!r) throw new Error("View engine is not specified");
        h.function.isFunction(t) && (s = t, t = void 0), s || (s = ((e, t) => {
            if (e) throw e;
            this.send(t);
        })), r.render(e, t, s);
    }
    /**
     * Send a response.
     *
     * @example
     * res.send(Buffer.from("wahoo"));
     * @example
     * res.send({ some: "json" });
     * @example
     * res.send("<p>some html</p>");
     */    send(e) {
        if (h.string.isString(e)) 
        // reflect this in content-type
        this.get("content-type") || this.setHeader("Content-Type", d("text/html", "utf-8")); else {
            if (!Buffer.isBuffer(e)) return this.json(e);
            // freshness
                        this.get("content-type") || this.type("bin");
        }
        this.fresh && (this.statusCode = HTTP.NOT_MODIFIED);
        const t = this.statusCode;
        // strip irrelevant headers
                return HTTP.NO_CONTENT !== t && HTTP.NOT_MODIFIED !== t || (this.removeHeader("content-type"), 
        this.removeHeader("content-length"), this.removeHeader("transfer-encoding"), e = ""), 
        // skip body for HEAD
        "HEAD" === this.req.method ? this.end() : this.end(e, "utf8"), this;
    }
    /**
     * Transfer the file at the given `path`.
     *
     * Automatically sets the _Content-Type_ response header field.
     * The callback `callback(err)` is invoked when the transfer is complete
     * or when an error occurs. Be sure to check `res.sentHeader`
     * if you wish to attempt responding, as the header and some data
     * may have already been transferred.
     *
     * Options:
     *   - `maxAge`   defaulting to 0 (can be string converted by `ms`)
     *   - `root`     root directory for relative filenames
     *   - `headers`  object of headers to serve with file
     *   - `dotfiles` serve dotfiles, defaulting to false; can be `"allow"` to send them
     *
     * Other options are passed along to `send`.
     *
     * @example
     * // The following example illustrates how `res.sendFile()` may
     * // be used as an alternative for the `static()` middleware for
     * // dynamic situations. The code backing `res.sendFile()` is actually
     * // the same code, so HTTP cache support etc is identical.
     *
     * app.get("/user/:uid/photos/:file", function(req, res) {
     *   let uid = req.params.uid;
     *   let file = req.params.file;
     *
     *   req.user.mayViewFilesFrom(uid, function(yes) {
     *     if (yes) {
     *       res.sendFile("/uploads/" + uid + "/" + file);
     *     } else {
     *       res.send(403, "Sorry! you cant see that.");
     *     }
     *   });
     * });
     */    sendFile(e, t, s) {
        let r = s;
        const n = this.req, i = this.next;
        let o = t || {};
        if (!e) throw new TypeError("path argument is required to res.sendFile");
        // support function as second arg
                if (h.function.isFunction(t) && (r = t, o = {}), !o.root && !y(e)) throw new TypeError("path must be absolute or specify root to res.sendFile");
        // create file stream
                const a = encodeURI(e), u = c(n, a, o);
        // transfer
        g(this, u, o, e => {
            if (r) return r(e);
            if (e && "EISDIR" === e.code) return i();
            // next() all but write errors
                        if (e && "ECONNABORTED" !== e.code && "write" !== e.syscall) throw e;
        });
    }
    /**
     * Send given HTTP status code.
     *
     * Sets the response status to `statusCode` and the body of the
     * response to the standard description from node's http.STATUS_CODES
     * or the statusCode number if no description.
     *
     * @example
     * res.sendStatus(200);
     */    sendStatus(e) {
        return this.statusCode = e, this.type("txt"), this.send(p[e] || `${e}`);
    }
    /**
     * Set response status code.
     *
     * @example
     * res.status(500);
     */    status(e) {
        return this.statusCode = e, this;
    }
    /**
     * Add `field` to Vary. If already present in the Vary set, then
     * this call is simply ignored.
     *
     * @returns for chaining
     */    vary(e) {
        return h.vary(this, e);
    }
}

/**
 *
 * @alias contentType
 */ E.prototype.type = E.prototype.contentType, 
/**
 *
 * @alias header
 */
E.prototype.set = E.prototype.header, 
/**
 * Get value for header `field`.
 *
 * @alias getHeader
 */
E.prototype.get = E.prototype.getHeader, module.exports = E;