/// <reference types="node" />
import * as Base from "events";
import { HttpException } from "../exceptions";
import * as Request from "../Request";
import * as Response from "../Response";
declare module EventEmitter {
    type ErrorEvent = "error" | "error-100" | "error-101" | "error-102" | "error-103" | "error-200" | "error-201" | "error-202" | "error-203" | "error-204" | "error-205" | "error-206" | "error-207" | "error-208" | "error-226" | "error-300" | "error-301" | "error-302" | "error-303" | "error-304" | "error-305" | "error-306" | "error-307" | "error-308" | "error-400" | "error-401" | "error-402" | "error-403" | "error-404" | "error-405" | "error-406" | "error-407" | "error-408" | "error-409" | "error-410" | "error-411" | "error-412" | "error-413" | "error-414" | "error-415" | "error-416" | "error-417" | "error-418" | "error-421" | "error-422" | "error-423" | "error-424" | "error-426" | "error-428" | "error-429" | "error-431" | "error-451" | "error-500" | "error-501" | "error-502" | "error-503" | "error-504" | "error-505" | "error-506" | "error-507" | "error-508" | "error-510" | "error-511";
    type ErrorListener = (error: HttpException, req: Request, res: Response) => void;
    type ExceptionListener = (error: Error) => void;
    type RejectionListener = (error: any) => void;
    type Event = "uncaughtException" | "unhandledRejection" | EventEmitter.ErrorEvent;
}
interface EventEmitter {
    on(event: EventEmitter.ErrorEvent, listener: EventEmitter.ErrorListener): this;
    on(event: "uncaughtException", listener: (error: Error) => void): this;
    on(event: "unhandledRejection", listener: (error: any) => void): this;
}
declare class EventEmitter extends Base {
    emit(event: EventEmitter.ErrorEvent, error: HttpException, req: Request, res: Response): boolean;
}
export = EventEmitter;
