"use strict";

require("./bootstrap");

const e = require("os"), t = require("serve-static"), r = require("@foxify/inject"), s = require("qs"), n = require("./constants"), i = require("./routing"), o = require("./utils"), a = require("./Server"), u = require("./Request"), p = require("./Response"), h = require("./events"), c = require("./view"), g = [ "https", "x-powered-by", "routing.case-sensitive", "routing.ignore-trailing-slash", "routing.allow-unsafe-regex", "json.escape" ], w = [ "env", "url", "port", "workers", "https.cert", "https.key", "json.spaces", "json.replacer", "query.parser", "routing.max-param-length", "subdomain.offset" ];

class l {
    constructor() {
        this._options = {
            https: !1,
            "x-powered-by": !0,
            routing: {
                "case-sensitive": !0,
                "ignore-trailing-slash": !1,
                "allow-unsafe-regex": !1
            },
            json: {
                escape: !1
            }
        }, this._settings = {
            env: process.env.NODE_ENV || "production",
            url: process.env.APP_URL || "localhost",
            port: process.env.APP_PORT ? +process.env.APP_PORT : 3e3,
            workers: process.env.WORKERS ? +process.env.WORKERS : e.cpus().length,
            subdomain: {
                offset: 2
            },
            https: {
                cert: void 0,
                key: void 0
            },
            json: {
                replacer: void 0,
                spaces: void 0
            },
            query: {
                parser: void 0
            },
            routing: {
                "max-param-length": 100
            }
        }, this._router = new i.Router(), 
        /* apply http routing methods */
        [ "route", "use", "all" ].concat(i.httpMethods).forEach(e => {
            this[e = e.toLowerCase()] || (this[e] = ((...t) => (this._router[e](...t), this)));
        });
    }
    /* handle options & settings */    _set(e, t, r) {
        const s = e.split(".");
        1 === s.length ? r[s[0]] = t : this._set(o.array.tail(s).join("."), t, r[s[0]]);
    }
    /* handle options */    enable(e) {
        if (!o.string.isString(e)) throw new TypeError("Argument 'option' should be an string");
        if (!o.array.contains(g, e)) throw new TypeError(`Unknown option '${e}'`);
        return this._set(e, !0, this._options), this;
    }
    disable(e) {
        if (!o.string.isString(e)) throw new TypeError("Argument 'option' should be an string");
        if (!o.array.contains(g, e)) throw new TypeError(`Unknown option '${e}'`);
        return this._set(e, !1, this._options), this;
    }
    enabled(e) {
        if (!o.string.isString(e)) throw new TypeError("Argument 'option' should be an string");
        if (!o.array.contains(g, e)) throw new TypeError(`Unknown option '${e}'`);
        const t = e.split(".");
        let r = this._options;
        return t.forEach(e => {
            if (o.boolean.isBoolean(r)) throw new Error("Unknown option");
            r = r[e];
        }), r;
    }
    disabled(e) {
        return !this.enabled(e);
    }
    /* handle settings */    set(e, t) {
        if (!o.string.isString(e)) throw new TypeError("Argument 'setting' should be an string");
        switch (e) {
          case "env":
          case "url":
            if (!o.string.isString(t)) throw new TypeError(`setting '${e}' should be an string`);
            break;

          case "port":
          case "workers":
            if (!o.number.isNumber(t)) throw new TypeError(`setting '${e}' should be a number`);
            if (t < 1) throw new TypeError(`setting '${e}' should be a positive number`);
            break;

          case "https.cert":
          case "https.key":
            if (!o.string.isString(t)) throw new TypeError(`setting '${e}' should be an string`);
            break;

          case "json.spaces":
          case "routing.max-param-length":
          case "subdomain.offset":
            if (null == t) break;
            if (!o.number.isNumber(t)) throw new TypeError(`setting '${e}' should be a number`);
            if (t < 0) throw new TypeError(`setting '${e}' should be a positive number or zero`);
            break;

          case "json.replacer":
          case "query.parser":
            if (null == t) break;
            if (!o.function.isFunction(t)) throw new TypeError(`setting '${e}' should be a function`);
            break;

          default:
            throw new TypeError(`Unknown setting '${e}'`);
        }
        return this._set(e, t, this._settings), this;
    }
    get(e, t, ...r) {
        if (!t) {
            const t = e;
            if (!o.string.isString(t)) throw new TypeError("'setting' should be an string");
            if (!o.array.contains(w, t)) throw new TypeError(`Unknown setting '${t}'`);
            const r = t.split(".");
            let s = this._settings;
            return r.map(e => {
                if (!o.object.isObject(s)) throw new Error("Unknown setting");
                s = s[e];
            }), s;
        }
        return this.use(new i.Router().get(e, t, ...r));
    }
    prettyPrint() {
        return this._router.prettyPrint();
    }
    /**
     * handle view
     * @param extension view template file extension
     * @param path the directory containing view templates
     */    engine(e, t, r) {
        return this._view = new c.Engine(t, e, r), this;
    }
    inject(e, t) {
        if ("test" !== this.get("env")) throw new Error('"inject" only works on testing environment');
        this._router.initialize(this), "string" == typeof e && (e = {
            url: e
        }), h.on("error", HttpException.handle);
        const n = this._options, i = Object.assign({}, this._settings, {
            view: this._view
        }), a = u;
        if (a.prototype.settings = {
            subdomain: Object.assign({}, i.subdomain)
        }, -1 === Object.getOwnPropertyNames(a.prototype).indexOf("query")) {
            const e = i.query.parser || s.parse;
            Object.defineProperty(a.prototype, "query", {
                get() {
                    return e(o.parseUrl(this).query, {
                        allowDots: !0
                    });
                }
            });
        }
        const c = p;
        return c.prototype.settings = {
            engine: i.view,
            json: {
                escape: n.json.escape,
                spaces: i.json.spaces,
                replacer: i.json.replacer
            }
        }, r(this._router.lookup.bind(this._router), Object.assign({}, e, {
            ServerResponse: c,
            IncomingMessage: a
        }), t);
    }
    start(e) {
        if (e && !o.function.isFunction(e)) throw new TypeError(`Expected 'callback' to be a function, got ${typeof e} instead`);
        /* set node env */        return process.env.NODE_ENV = this.get("env"), 
        /* initialize the router with provided options and settings */
        this._router.initialize(this), new a(this._options, Object.assign({}, this._settings, {
            view: this._view
        }), this._router.lookup.bind(this._router)).start(e);
    }
}

l.constants = n, l.Router = i.Router, l.static = t, l.dotenv = (e => {
    if (!o.string.isString(e)) throw new TypeError(`Expected 'dotenv' to be an string, got ${typeof e} instead`);
    require("dotenv").config({
        path: e
    });
}), module.exports = l;