"use strict";

const e = require("assert"), t = require("./httpMethods"), n = require("../exceptions"), r = {
    schema: {
        response: {}
    }
}, h = (e => {
    let n = "handlers = handlers || {}\n  ";
    for (let e = 0; e < t.default.length; e++) {
        const h = t.default[e];
        n += `this["${h}"] = handlers["${h}"] || {\n      handlers: [],\n      handlersLength: 0,\n      params: [],\n      paramsLength: 0,\n      options: ${JSON.stringify(r)},\n      prettyPrint: false\n    }\n    `;
    }
    return new Function("handlers", n);
 // eslint-disable-line
})(), s = {
    STATIC: 0,
    PARAM: 1,
    MATCH_ALL: 2,
    REGEX: 3,
    // It's used for a parameter, that is followed by another parameter in the same part
    MULTI_PARAM: 4
};

class i {
    constructor(e = "/", n = {}, r = s.STATIC, i = null, l = [], a) {
        this.prefix = e, this.children = n, this.kind = r, this.regex = i, this.params = l, 
        this.wildcardChild = null, this.parametricBrother = null, this.numberOfChildren = Object.keys(this.children).length, 
        this.handlers = new h(a);
        const d = l.length;
        t.default.forEach(e => {
            this.handlers[e].params = l, this.handlers[e].paramsLength = d;
        });
    }
    get label() {
        return this.prefix[0];
    }
    addChild(t) {
        let n = "";
        switch (t.kind) {
          case s.STATIC:
            n = t.label;
            break;

          case s.PARAM:
          case s.REGEX:
          case s.MULTI_PARAM:
            n = ":";
            break;

          case s.MATCH_ALL:
            this.wildcardChild = t, n = "*";
            break;

          default:
            throw new Error(`Unknown layer kind: ${t.kind}`);
        }
        e(void 0 === this.children[n], `There is already a child with label "${n}"`), this.children[n] = t, 
        this.numberOfChildren++;
        const r = Object.keys(this.children);
        let h = null;
        for (let e = 0; e < r.length; e++) {
            const t = this.children[r[e]];
            if (":" === t.label) {
                h = t;
                break;
            }
        }
        // Save the parametric brother inside a static children
                for (let e = 0; e < r.length; e++) {
            const t = this.children[r[e]];
            t.kind === s.STATIC && h && (t.parametricBrother = h);
        }
        return this;
    }
    reset(e = "/") {
        return this.prefix = e, this.children = {}, this.kind = s.STATIC, this.handlers = new h(), 
        this.regex = null, this.wildcardChild = null, this.numberOfChildren = 0, this;
    }
    findByLabel(e) {
        return this.children[e[0]];
    }
    findChild(e, t) {
        let n = this.children[e[0]];
        return void 0 !== n && (n.numberOfChildren > 0 || 0 !== n.handlers[t].handlersLength) && e.slice(0, n.prefix.length) === n.prefix ? n : void 0 !== (n = this.children[":"] || this.children["*"]) && (n.numberOfChildren > 0 || 0 !== n.handlers[t].handlersLength) ? n : null;
    }
    addHandler(e, t = r, h, s = !1) {
        const i = h.length;
        return 0 === i ? this : (this.handlers[e].handlers.push(...h.map(e => new n.Encapsulation(e))), 
        this.handlers[e].handlersLength += i, this.handlers[e].options = Object.assign({}, r, t, {
            schema: t.schema || {
                response: {}
            }
        }), this.handlers[e].prettyPrint = this.handlers[e].prettyPrint || s, this);
    }
    getHandler(e) {
        return this.handlers[e];
    }
    prettyPrint(e, t = !1) {
        const n = this.handlers, r = Object.keys(n).filter(e => n[e].prettyPrint);
        let h = "";
        if (":" === this.prefix) {
            const e = this.params, t = e[e.length - 1];
            r.forEach((e, n) => {
                if (r.length > 1) {
                    if (0 === n) return void (h += `${t} (${e}`);
                    h += `|${e}`, h += n === r.length - 1 ? ")" : "";
                } else h = `${t} (${e})`;
            });
        } else r.length && (h = ` (${r.join("|")})`);
        let s = `${e}${t ? "└── " : "├── "}${this.prefix}${h}\n`;
        e = `${e}${t ? "    " : "│   "}`;
        const i = Object.keys(this.children);
        for (let t = 0; t < i.length - 1; t++) s += this.children[i[t]].prettyPrint(e);
        return i.length > 0 && (s += this.children[i[i.length - 1]].prettyPrint(e, !0)), 
        s;
    }
}

i.isLayer = (e => e instanceof i), i.TYPES = s, i.Handlers = h, module.exports = i;