"use strict";

const e = require("assert"), t = require("fast-json-stringify"), s = require("safe-regex"), r = require("../utils"), i = require("../exceptions"), n = require("../middlewares"), a = require("./httpMethods"), l = require("./Layer"), h = {
    schema: {
        response: {}
    }
}, o = l.TYPES;

function d() {
    throw new HttpException(HTTP.NOT_FOUND);
}

const c = {
    handlers: [ new i.Encapsulation(d) ],
    options: h,
    params: {}
}, u = (e, t) => {
    const s = t.replace(/(^\/|\/$)/g, "").split("/"), r = e.replace(/(^\/|\/$)/g, "").split("/"), i = s.length;
    for (let e = 0; e < i; e++) {
        const t = s[e], n = r[e];
        if ("*" !== t) {
            if (!n || t !== n) return !1;
            if (e === i - 1) return !0;
        } else if (e === i - 1) return !0;
    }
    return !1;
}, f = (e, t, s, i) => {
    if (null === e) return c;
    const n = r.decodeURIComponent(s.slice(-i));
    if (null === n) return c;
    const a = e.getHandler(t);
    return a.handlersLength > 0 ? {
        handlers: a.handlers,
        options: a.options,
        params: {
            "*": n
        }
    } : c;
}, p = (e, t) => {
    // `path.indexOf()` will always return the first position of the closing parenthese,
    // but it's inefficient for grouped or wrong regexp expressions.
    // see issues #62 and #63 for more info
    let s = 1;
    for (;t < e.length; ) 
    // ignore skipped chars
    if ("\\" !== e[++t]) {
        if (")" === e[t] ? s-- : "(" === e[t] && s++, !s) return t;
    } else t++;
    throw new TypeError(`Invalid regexp expression in "${e}"`);
};

class m {
    constructor(t = "") {
        this.prefix = t, this.tree = new l(), this.middlewares = [], this.routes = [], this.params = {}, 
        this.caseSensitive = !0, this.ignoreTrailingSlash = !1, this.maxParamLength = 100, 
        this.allowUnsafeRegex = !1, this._next = ((e, t, s, r = 0) => {
            const i = () => this._safeNext.run(e, t, s, r + 1);
            t.next = i, s[r].run(e, t, i);
        }), this._safeNext = new i.Encapsulation(this._next), e("string" == typeof t, "Prefix should be a string"), 
        a.default.forEach(e => {
            const t = e.toLowerCase();
            if (this[t]) throw new Error(`Method already exists: ${t}`);
            this[t] = ((t, s, ...r) => this.on(e, t, s, ...r));
        });
    }
    _on(t, s, r = h, i) {
        return Array.isArray(t) ? (t.forEach(e => this._on(e, s, r, i)), this) : (
        // method validation
        e("string" == typeof t, "Method should be a string"), e(-1 !== a.default.indexOf(t), `Method "${t}" is not an http method.`), 
        this.routes.push({
            method: t,
            path: `${this.prefix}${s}`,
            opts: r,
            handlers: i,
            middlewares: []
        }), this);
    }
    _insert(t, s, r, i = h, n = [], a = [], o = [], d) {
        const c = 0 !== a.length;
        a = o.concat(n.filter(e => void 0 !== this.params[e]).map(e => this.params[e])).concat(a);
        const u = s;
        let f = this.tree, p = "", m = 0, g = 0, w = 0, x = 0, C = null;
        for (;;) {
            for (g = (p = f.prefix).length, w = 0, 
            // search for the longest common prefix
            x = (m = s.length) < g ? m : g; w < x && s[w] === p[w]; ) w++;
            // the longest common prefix is smaller than the current prefix
            // let's split the node and add a new child
                        if (w < g) C = new l(p.slice(w), f.children, f.kind, f.regex, n, new l.Handlers(f.handlers)), 
            null !== f.wildcardChild && (C.wildcardChild = f.wildcardChild), 
            // reset the parent
            f.reset(p.slice(0, w)).addChild(C), 
            // if the longest common prefix has the same length of the current path
            // the handler should be added to the current node, to a child otherwise
            w === m ? (e(0 === f.getHandler(t).handlersLength, `Method "${t}" already declared for route "${u}"`), 
            f.addHandler(t, i, a, c), f.kind = r) : ((C = new l(s.slice(w), {}, r, d, n)).addHandler(t, i, a, c), 
            f.addChild(C)); else if (w < m) {
                // there is a child within the given label, we must go deepen in the tree
                if (
                // remove the prefix
                s = s.slice(w), 
                // check if there is a child with the label extracted from the new path
                C = f.findByLabel(s)) {
                    f = C;
                    continue;
                }
                // there are not children within the given label, let's create a new one!
                                (C = new l(s, {}, r, d, n)).addHandler(t, i, a, c), f.addChild(C);
            } else a && 
            // assert(!currentNode.getHandler(method), `Method "${method}" already declared for route "${route}"`);
            f.addHandler(t, i, a, c);
            // }
                        return this;
        }
    }
    /* handle built-in middlewares */    _use(...t) {
        // handler validation
        (t = r.array.compact(t)).forEach(t => e("function" == typeof t, "Handler should be a function"));
        const s = this.middlewares.findIndex(e => "*" === e.path);
        return -1 === s ? this.middlewares.push({
            path: "*",
            handlers: t
        }) : this.middlewares[s].handlers = t.concat(this.middlewares[s].handlers), this;
    }
    initialize(i) {
        this.caseSensitive = i.enabled("routing.case-sensitive"), this.ignoreTrailingSlash = i.enabled("routing.ignore-trailing-slash"), 
        this.allowUnsafeRegex = i.enabled("routing.allow-unsafe-regex"), this.maxParamLength = i.get("routing.max-param-length"), 
        /* apply built-in middlewares */
        this._use(n.init(i));
        const l = this.middlewares.reduce((e, {path: t, handlers: s}) => (a.default.forEach(r => e.push({
            path: t,
            handlers: [],
            opts: h,
            method: r,
            middlewares: s
        })), e), []);
        let c = this.routes.reduce((e, {method: s, path: i, opts: n, handlers: a}) => {
            const h = n, o = h.schema;
            o && (o.response = r.object.mapValues(o.response || {}, e => t(e))), h.schema = o;
            const d = l.filter(e => s === e.method && u(i, e.path)).reduce((e, {middlewares: t}) => e.concat(t), []), c = [ {
                method: s,
                path: i,
                opts: h,
                handlers: a,
                middlewares: d
            } ];
            if (this.ignoreTrailingSlash && "/" !== i && !i.endsWith("*")) {
                let e = {
                    method: s,
                    path: `${i}/`,
                    opts: h,
                    handlers: a,
                    middlewares: d
                };
                i.endsWith("/") && (e = {
                    method: s,
                    path: i.slice(0, -1),
                    opts: h,
                    handlers: a,
                    middlewares: d
                }), c.push(e);
            }
            return e.concat(c);
        }, []);
        const f = l.filter(e => "*" === e.path);
        return f && (c = f.concat(c)), (c = c.map(e => (e.handlers = e.handlers.concat([ d ]), 
        e))).concat(l.filter(e => !/\*/.test(e.path)).map(e => (e.handlers = e.handlers.concat([ d ]), 
        e))).forEach(({method: t, path: r, opts: i, handlers: n, middlewares: a}) => {
            const l = [];
            let h = 0;
            for (let d = 0, c = r.length; d < c; d++) 
            // search for parametric or wildcard routes
            // parametric route
            if (58 === r.charCodeAt(d)) {
                let u = o.PARAM, f = r.slice(0, d);
                h = d + 1, this.caseSensitive || (f = f.toLowerCase()), 
                // add the static part of the route to the tree
                this._insert(t, f, o.STATIC, i, void 0, void 0, void 0, null);
                // isolate the parameter name
                let m = !1;
                for (;d < c && 47 !== r.charCodeAt(d); ) {
                    if (m = m || "(" === r[d]) {
                        d = p(r, d) + 1;
                        break;
                    }
                    if (45 === r.charCodeAt(d)) break;
                    d++;
                }
                !m || d !== c && 47 !== r.charCodeAt(d) ? d < c && 47 !== r.charCodeAt(d) && (u = o.MULTI_PARAM) : u = o.REGEX;
                const g = r.slice(h, d);
                let w = m ? g.slice(g.indexOf("("), d) : null;
                // if the path is ended
                if (m && (w = new RegExp(w), this.allowUnsafeRegex || e(s(w), `The regex "${w.toString()}" is not safe!`)), 
                l.push(g.slice(0, m ? g.indexOf("(") : d)), r = r.slice(0, h) + r.slice(d), (d = h) === (c = r.length)) return this._insert(t, r.slice(0, d), u, i, l, n, a, w);
                // add the parameter and continue with the search
                                this._insert(t, r.slice(0, d), u, i, l, void 0, void 0, w), d--;
            } else if (42 === r.charCodeAt(d)) return this._insert(t, r.slice(0, d), o.STATIC, i, void 0, void 0, void 0, null), 
            // add the wildcard parameter
            l.push("*"), this._insert(t, r.slice(0, c), o.MATCH_ALL, i, l, n, a, null);
            // static route
            return this.caseSensitive || (r = r.toLowerCase()), this._insert(t, r, o.STATIC, i, l, n, a, null);
        }), this;
    }
    on(t, s, i, ...n) {
        return r.function.isFunction(i) && (n = [ i ].concat(n), i = {}), 
        // path validation
        e("string" == typeof s, "Path should be a string"), e(`${this.prefix}${s}`.length > 0, "The path could not be empty"), 
        e("/" === s[0] || "*" === s[0], "The first character of a path should be `/` or `*`"), 
        // handler validation
        n.forEach(t => e("function" == typeof t, "Handler should be a function")), this._on(t, s, i, n);
    }
    route(e) {
        const t = a.default.reduce((s, r) => {
            const i = r.toLowerCase();
            if (s[i]) throw new Error(`Method already exists: ${i}`);
            return s[i] = ((s, ...i) => (this.on(r, e, s, ...i), t)), s;
        }, {});
        return t;
    }
    use(t, ...s) {
        let i = (s = r.array.compact(s)).filter(m.isRouter);
        m.isRouter(t) && (i = [ t ].concat(i), t = "*"), r.function.isFunction(t) && (s = [ t ].concat(s), 
        t = "*"), s = s.filter(e => !m.isRouter(e)), 
        // path validation
        e("string" == typeof t, "Path should be a string"), e(t.length > 0, "The path could not be empty"), 
        e("/" === t[0] || "*" === t[0], "The first character of a path should be `/` or `*`"), 
        // handler validation
        s.forEach(t => e("function" == typeof t, "Handler should be a function"));
        const n = "" === this.prefix ? t : "*" === t ? `${this.prefix}/${t}` : `${this.prefix}${t}`, a = this.middlewares.findIndex(e => n === e.path);
        -1 === a ? this.middlewares.push({
            path: n,
            handlers: s
        }) : this.middlewares[a].handlers.push(...s);
        const l = `${this.prefix}${"*" === t ? "" : t}`;
        return i.forEach(e => {
            e.middlewares.forEach(e => this.use(`${l}${e.path}`, ...e.handlers)), this.routes = this.routes.concat(e.routes.map(e => Object.assign({}, e, {
                path: `${l}${e.path}`
            }))), this.params = Object.assign({}, this.params, e.params);
        }), this;
    }
    param(t, s) {
        // path validation
        return e("string" == typeof t, "Param should be a string"), e(t.length > 0, "The param could not be empty"), 
        e(!/\//.test(t), "The first character of a param shouldn't have `/`"), 
        // handler validation
        e("function" == typeof s, "Handler should be a function"), this.params[t] = s, this;
    }
    reset() {
        return this.tree = new l(), this.middlewares = [], this.routes = [], this.params = {}, 
        this;
    }
    lookup(e, t) {
        const s = this.find(e.method, e.path);
        e.params = s.params, t.stringify = s.options.schema.response, this._safeNext.run(e, t, s.handlers);
    }
    find(e, t) {
        this.caseSensitive || (t = t.toLowerCase());
        const s = this.maxParamLength, i = t, n = [];
        let a = this.tree, l = null, h = 0, d = null, u = 0, p = 0;
        for (;;) {
            const m = a.prefix;
            let g = t.length;
            // found the route
                        if (0 === g || t === m) {
                const t = a.getHandler(e);
                if (t.handlersLength > 0) {
                    const e = {};
                    if (t.paramsLength > 0) {
                        const s = t.params;
                        for (p = 0; p < t.paramsLength; p++) e[s[p]] = n[p];
                    }
                    return {
                        handlers: t.handlers,
                        options: t.options,
                        params: e
                    };
                }
            }
            const w = m.length;
            let x = 0;
            // search for the longest common prefix
                        for (p = g < w ? g : w; x < p && t.charCodeAt(x) === m.charCodeAt(x); ) x++;
            const C = t;
            x === w && (g = (t = t.slice(x)).length);
            let A = a.findChild(t, e);
            if (null === A) {
                if (null === (A = a.parametricBrother)) return f(l, e, i, h);
                t = C, g = C.length, x = w;
            }
            const y = A.kind;
            // static route
                        if (y !== o.STATIC) {
                if (x !== w) return f(l, e, i, h);
                // if exist, save the wildcard child
                                // parametric route
                if (null !== a.wildcardChild && (l = a.wildcardChild, h = g), y !== o.PARAM) 
                // wildcard route
                if (y !== o.MATCH_ALL) 
                // parametric(regex) route
                if (y !== o.REGEX) 
                // multiparametric route
                if (y !== o.MULTI_PARAM) l = null; else {
                    if (a = A, p = 0, null !== A.regex) {
                        const e = t.match(A.regex);
                        if (null === e) return c;
                        p = e[1].length;
                    } else {
                        for (;p < g && 47 !== t.charCodeAt(p) && 45 !== t.charCodeAt(p); ) p++;
                        if (p > s) return c;
                    }
                    if (null === (d = r.decodeURIComponent(t.slice(0, p)))) return c;
                    n[u++] = d, t = t.slice(p);
                } else {
                    if (a = A, -1 === (p = t.indexOf("/")) && (p = g), p > s) return c;
                    if (null === (d = r.decodeURIComponent(t.slice(0, p)))) return c;
                    if (!A.regex.test(d)) return c;
                    n[u++] = d, t = t.slice(p);
                } else {
                    if (null === (d = r.decodeURIComponent(t))) return c;
                    n[u] = d, a = A, t = "";
                } else {
                    if (a = A, -1 === (p = t.indexOf("/")) && (p = g), p > s) return c;
                    if (null === (d = r.decodeURIComponent(t.slice(0, p)))) return c;
                    n[u++] = d, t = t.slice(p);
                }
            } else 
            // if exist, save the wildcard child
            null !== a.wildcardChild && (l = a.wildcardChild, h = g), a = A;
        }
    }
    prettyPrint() {
        return this.tree.prettyPrint("", !0);
    }
    all(e, ...t) {
        return this.on.apply(this, [ a.default, e, ...t ]);
    }
}

m.isRouter = (e => e instanceof m), module.exports = m;