"use strict";

/**
 * (The MIT License)
 *
 * Copyright (c) 2012 TJ Holowaychuk <tj@vision-media.ca>
 * Copyright (c) 2016-2017 Douglas Christopher Wilson <doug@somethingdoug.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * 'Software'), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */ Object.defineProperty(exports, "__esModule", {
    value: !0
});

/**
 * RegExp to check for no-cache token in Cache-Control.
 * @private
 */
const e = /(?:^|,)\s*?no-cache\s*?(?:,|$)/, t = e => {
    const t = e && Date.parse(e);
    // istanbul ignore next: guard against date.js Date.parse patching
        return "number" == typeof t ? t : NaN;
};

/**
 * Parse an HTTP Date into a number.
 *
 * @param {string} date
 * @private
 */ exports.default = ((n, o) => {
    // fields
    const r = n["if-modified-since"], s = n["if-none-match"];
    // unconditional request
    if (!r && !s) return !1;
    // Always return stale when Cache-Control: no-cache
    // to support end-to-end reload requests
    // https://tools.ietf.org/html/rfc2616#section-14.9.4
        const c = n["cache-control"];
    return !(c && e.test(c) || s && "*" !== s || r && !o || !(t(o) <= t(r)));
    // if-none-match
});