"use strict";

/**
 * (The MIT License)
 *
 * Copyright (c) 2014 Jonathan Ong <me@jongleberry.com>
 * Copyright (c) 2014-2017 Douglas Christopher Wilson <doug@somethingdoug.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * 'Software'), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */ Object.defineProperty(exports, "__esModule", {
    value: !0
});

/**
 * This module is modified and optimized for Foxify specifically
 */
const e = require("url");

/**
 * Parse the `str` url with fast-path short-cut.
 *
 * @param {string} str
 * @return {Object}
 * @private
 */ exports.default = (r => r._parsedUrl = r._parsedUrl || (r => {
    if (47 /* / */ !== r.charCodeAt(0)) return e.parse(r);
    let s = r, a = null, t = null;
    // This takes the regexp from https://github.com/joyent/node/pull/7878
    // Which is /^(\/[^?#\s]*)(\?[^#\s]*)?$/
    // And unrolls it into a for loop
    for (let u = 1; u < r.length; u++) switch (r.charCodeAt(u)) {
      case 63:
        /* ?  */
        null === t && (s = r.substring(0, u), a = r.substring(u + 1), t = r.substring(u));
        break;

      case 9:
 /* \t */      case 10:
 /* \n */      case 12:
 /* \f */      case 13:
 /* \r */      case 32:
 /*    */      case 35:
 /* #  */      case 160:
      case 65279:
        return e.parse(r);
    }
    return {
        path: r,
        href: r,
        pathname: s,
        query: a,
        search: t
    };
})(r.url));