"use strict";

/**
 * (The MIT License)
 *
 * Copyright (c) 2014-2017 Douglas Christopher Wilson
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * 'Software'), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */ Object.defineProperty(exports, "__esModule", {
    value: !0
});

/**
 * RegExp to match field-name in RFC 7230 sec 3.2
 *
 * field-name    = token
 * token         = 1*tchar
 * tchar         = "!" / "#" / "$" / "%" / "&" / "'" / "*"
 *               / "+" / "-" / "." / "^" / "_" / "`" / "|" / "~"
 *               / DIGIT / ALPHA
 *               ; any VCHAR, except delimiters
 */
const e = /^[!#$%&'*+\-.^_`|~0-9A-Za-z]+$/, r = (r, n) => {
    if (!n) throw new TypeError("field argument is required");
    // get fields array
        const s = Array.isArray(n) ? n : t(String(n));
    // assert on invalid field names
        for (let r = 0; r < s.length; r++) if (!e.test(s[r])) throw new TypeError("field argument contains an invalid header name");
    // existing, unspecified vary
        if ("*" === r) return r;
    // enumerate current values
        const a = t(r.toLowerCase());
    let o = r;
    // unspecified vary
        if (-1 !== s.indexOf("*") || -1 !== a.indexOf("*")) return "*";
    for (let e = 0; e < s.length; e++) {
        const r = s[e].toLowerCase();
        // append value (case-preserving)
                -1 === a.indexOf(r) && (a.push(r), o = o ? o + ", " + s[e] : s[e]);
    }
    return o;
}, t = e => {
    const r = [];
    let t = 0, n = 0;
    // gather tokens
    for (let s = 0, a = e.length; s < a; s++) switch (e.charCodeAt(s)) {
      case 32:
        /*   */
        t === n && (t = n = s + 1);
        break;

      case 44:
        /* , */
        r.push(e.substring(t, n)), t = n = s + 1;
        break;

      default:
        n = s + 1;
    }
    // final token
        return r.push(e.substring(t, n)), r;
};

/**
 * Append a field to a vary header.
 *
 * @param {String} header
 * @param {String|Array} field
 * @return {String}
 * @public
 */ exports.default = 
/**
 * Mark that a request is varied on a header field.
 *
 * @public
 */
function(e, t) {
    // get existing header
    let n = e.get("vary") || "";
    const s = Array.isArray(n) ? n.join(", ") : `${n}`;
    // set new header
    return (n = r(s, t)) && e.setHeader("vary", n), e;
};